Index: trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/read_data_GCM.F90	(revision 2794)
@@ -0,0 +1,307 @@
+!
+! $Id $
+!
+SUBROUTINE read_data_GCM(fichnom,min_h2o_ice_s,min_co2_ice_s,iim_input,jjm_input,nlayer,vmr_co2_gcm,ps_GCM,timelen, & 
+             min_co2_ice_slope,min_h2o_ice_slope,nslope,tsurf_ave,tsoil_ave,tsurf_gcm,tsoil_gcm,TI_ave,q_co2_GCM,q_h2o_GCM,co2_ice_slope)
+
+      use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
+                        nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
+                        nf90_inquire_dimension,nf90_close
+      use comsoil_h, only: nsoilmx
+
+      IMPLICIT NONE
+
+!=======================================================================
+!
+! Read initial confitions file
+!
+!=======================================================================
+
+  include "dimensions.h"
+
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+
+  INTEGER :: iim_input,jjm_input,nlayer,nslope
+  REAL, ALLOCATABLE ::  h2o_ice_s(:,:,:)                       ! h2o_ice_s of the concatenated file
+  REAL, ALLOCATABLE ::  co2_ice_s(:,:,:)                       ! co2_ice_s of the concatenated file
+
+  REAL, ALLOCATABLE ::  h2o_ice_s_slope(:,:,:,:)                       ! co2_ice_s of the concatenated file
+
+  REAL, INTENT(OUT) ::  min_h2o_ice_s(iim_input+1,jjm_input+1) ! Minimum of h2o_ice_s of the year
+  REAL, INTENT(OUT) ::  min_co2_ice_s(iim_input+1,jjm_input+1) ! Minimum of co2_ice_s of the year
+  REAL, INTENT(OUT) ::  min_co2_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
+  REAL, INTENT(OUT) ::  min_h2o_ice_slope(iim_input+1,jjm_input+1,nslope) ! Minimum of co2_ice slope of the year
+!  REAL, ALLOCATABLE ::  vmr_co2_gcm(:,:,:)                     !!!!vmr_co2_phys_gcm(iim_input+1,jjm_input+1,timelen)
+  REAL, INTENT(OUT) ::  vmr_co2_gcm(iim_input+1,jjm_input+1,2676)                     !!!!vmr_co2_phys_gcm(iim_input+1,jjm_input+1,timelen)
+!  REAL, ALLOCATABLE ::  q_h2o_GCM(:,:,:)
+  REAL, INTENT(OUT) ::  q_h2o_GCM(iim_input+1,jjm_input+1,2676)
+  REAL, INTENT(OUT) ::  q_co2_GCM(iim_input+1,jjm_input+1,2676)
+!  REAL, ALLOCATABLE ::  q_co2_GCM(:,:,:)
+  REAL, ALLOCATABLE ::  q1_co2_GCM(:,:,:)
+!  real, INTENT(OUT) ::  vmr_co2_phys_gcm(:,:)                  !!!!vmr_co2_gcm(ngrid,timelen)
+!  REAL, ALLOCATABLE ::  ps_GCM(:,:,:)
+  REAL,  INTENT(OUT) ::  ps_GCM(iim_input+1,jjm_input+1,2676)
+
+
+!SOIL
+  REAL, INTENT(OUT) ::  tsurf_ave(iim_input+1,jjm_input+1,nslope) ! Average surface temperature of the concatenated file
+  REAL, INTENT(OUT) ::  tsoil_ave(iim_input+1,jjm_input+1,nsoilmx,nslope) ! Average soil temperature of the concatenated file
+
+  REAL ,INTENT(OUT) ::  tsurf_gcm(iim_input+1,jjm_input+1,nslope,2676) ! Surface temperature of the concatenated file
+  REAL , INTENT(OUT) ::  tsoil_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,2676) ! Soil temperature of the concatenated file
+
+  REAL ::  TI_gcm(iim_input+1,jjm_input+1,nsoilmx,nslope,2676) ! Thermal Inertia  of the concatenated file
+  REAL, INTENT(OUT) ::  TI_ave(iim_input+1,jjm_input+1,nsoilmx,nslope) ! Average Thermal Inertia  of the concatenated file
+  REAL, INTENT(OUT) ::  co2_ice_slope(iim_input+1,jjm_input+1,nslope,2676) ! Minimum of co2_ice slope of the year
+!===============================================================================
+!   Local Variables 
+  CHARACTER(LEN=256) :: msg, var, modname
+  INTEGER,PARAMETER :: length=100
+  INTEGER :: iq, fID, vID, idecal
+  INTEGER :: ierr
+  CHARACTER(len=12) :: start_file_type="earth" ! default start file type
+
+  REAL,ALLOCATABLE :: time(:) ! times stored in start
+  INTEGER :: timelen ! number of times stored in the file
+  INTEGER :: indextime ! index of selected time
+
+  INTEGER :: edges(4),corner(4)
+  INTEGER :: i,j,t
+  real,save :: m_co2, m_noco2, A , B, mmean
+
+  INTEGER :: islope
+  CHARACTER*2 :: num
+
+
+!-----------------------------------------------------------------------
+  modname="pemetat0"
+
+      m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
+      m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+
+!  Open initial state NetCDF file
+  var=fichnom
+  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+
+      ierr = nf90_inq_varid (fID, "temps", vID)
+      IF (ierr .NE. nf90_noerr) THEN
+        write(*,*)"pemetat0: Le champ <temps> est absent"
+        write(*,*)"pemetat0: J essaie <Time>"
+        ierr = nf90_inq_varid (fID, "Time", vID)
+        IF (ierr .NE. nf90_noerr) THEN
+           write(*,*)"pemetat0: Le champ <Time> est absent"
+           write(*,*)trim(nf90_strerror(ierr))
+     print *, "ICIIII0"
+           CALL ABORT_gcm("pemetat0", "", 1)
+        ENDIF
+        ! Get the length of the "Time" dimension
+     print *, "ICIIIITIME"
+        ierr = nf90_inq_dimid(fID,"Time",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
+      ELSE   
+        ! Get the length of the "temps" dimension
+     print *, "ICIIIITEMPS"
+        ierr = nf90_inq_dimid(fID,"temps",vID)
+        ierr = nf90_inquire_dimension(fID,vID,len=timelen)
+      ENDIF
+
+     print *, "ICIIII"
+
+      allocate(co2_ice_s(iim+1,jjm+1,timelen))
+
+     print *, "ICIIIIAAAA"
+
+!      allocate(q_co2_GCM(iim+1,jjm+1,timelen))
+
+     print *, "ICIIIIBBBB"
+
+!      allocate(q_h2o_GCM(iim+1,jjm+1,timelen))
+
+     print *, "ICIIIICCCC"
+
+      allocate(q1_co2_GCM(iim+1,jjm+1,timelen))
+
+     print *, "ICIIII2"
+
+
+
+      allocate(h2o_ice_s_slope(iim+1,jjm+1,nslope,timelen))
+      allocate(h2o_ice_s(iim+1,jjm+1,timelen))
+          print *, "ICIIII3"
+
+! Get h2o_ice_s of the concatenated file
+  CALL get_var3("h2o_ice_s"   ,h2o_ice_s)
+
+  print *, "A"
+
+  CALL get_var3("co2ice"   ,co2_ice_s)
+  CALL get_var3("co2_cropped"   ,q_co2_GCM)
+  CALL get_var3("h2o_cropped"   ,q_h2o_GCM)
+
+  print *, "B"
+
+  CALL get_var3("ps"   ,ps_GCM)
+
+  print *, "C"
+
+  print *, "nslope", nslope
+
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call get_var3("co2ice_slope"//num,co2_ice_slope(:,:,islope,:))
+ENDDO
+
+  print *, "co2ice_slope"
+
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call get_var3("h2o_ice_s_slope"//num,h2o_ice_s_slope(:,:,islope,:))
+ENDDO
+
+  print *, "h2o_ice_s_slope"
+
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call get_var3("tsurf_slope"//num,tsurf_gcm(:,:,islope,:))
+ENDDO
+
+  print *, "tsurf_slope"
+
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call get_var4("tsoil_slope"//num,tsoil_gcm(:,:,:,islope,:))
+ENDDO
+
+  print *, "tsoil_slope"
+
+DO islope=1,nslope
+  write(num,fmt='(i2.2)') islope
+  call get_var4("inertiesoil_slope"//num,TI_gcm(:,:,:,islope,:))
+ENDDO
+
+  print *, "inertiesoil_slope"
+
+
+
+
+
+! Compute the minimum over the year for each point
+  min_h2o_ice_s(:,:)=minval(h2o_ice_s,3)
+  min_co2_ice_s(:,:)=minval(co2_ice_s,3)
+
+  min_co2_ice_slope(:,:,:)=minval(co2_ice_slope,4)
+  min_h2o_ice_slope(:,:,:)=minval(h2o_ice_s_slope,4)
+
+!Compute averages
+
+!  DO i=1,timelen
+    tsurf_ave(:,:,:)=SUM(tsurf_gcm(:,:,:,:),4)/timelen
+    tsoil_ave(:,:,:,:)=SUM(tsoil_gcm(:,:,:,:,:),5)/timelen
+    TI_ave(:,:,:,:)=SUM(TI_gcm(:,:,:,:,:),5)/timelen
+!  ENDDO
+
+
+
+
+! By definition, a density is positive, we get rid of the negative values
+  DO i=1,iim+1
+    DO j = 1, jjm+1
+       if (min_co2_ice_s(i,j).LT.0) then
+          min_h2o_ice_s(i,j)  = 0.
+          min_co2_ice_s(i,j)  = 0.
+       endif
+       DO islope=1,nslope
+          if (min_co2_ice_slope(i,j,islope).LT.0) then
+            min_co2_ice_slope(i,j,islope)  = 0.
+          endif
+          if (min_h2o_ice_slope(i,j,islope).LT.0) then
+            min_h2o_ice_slope(i,j,islope)  = 0.
+          endif
+       ENDDO
+    ENDDO
+  ENDDO
+
+  DO i=1,iim+1
+    DO j = 1, jjm+1
+      DO t = 1, timelen
+!         q1_co2_GCM(i,j,t)=q_co2_GCM(i,j,t)
+!         ps_GCM(i,j,t)=ps(i)
+!c             Mean air molecular mass = 1/(q(ico2)/m_co2 + (1-q(ico2))/m_noco2)
+         if (q_co2_GCM(i,j,t).LT.0) then
+              q_co2_GCM(i,j,t)=1E-10
+         elseif (q_co2_GCM(i,j,t).GT.1) then
+              q_co2_GCM(i,j,t)=1.
+         endif
+         if (q_h2o_GCM(i,j,t).LT.0) then
+              q_h2o_GCM(i,j,t)=1E-30
+         elseif (q_h2o_GCM(i,j,t).GT.1) then
+              q_h2o_GCM(i,j,t)=1.
+         endif
+         mmean=1/(A*q_co2_GCM(i,j,t) +B)
+         vmr_co2_gcm(i,j,t) = q_co2_GCM(i,j,t)*mmean/m_co2
+      ENDDO
+    ENDDO
+  ENDDO
+
+
+
+
+
+
+  CONTAINS
+
+SUBROUTINE check_dim(n1,n2,str1,str2)
+  INTEGER,          INTENT(IN) :: n1, n2
+  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
+  CHARACTER(LEN=256) :: s1, s2
+  IF(n1/=n2) THEN
+    s1='value of '//TRIM(str1)//' ='
+    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
+    WRITE(msg,'(10x,a,i4,2x,a,i4)')TRIM(s1),n1,TRIM(s2),n2
+    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
+  END IF
+END SUBROUTINE check_dim
+
+
+SUBROUTINE get_var1(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var1
+
+
+SUBROUTINE get_var3(var,v) ! on U grid
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+
+END SUBROUTINE get_var3
+
+SUBROUTINE get_var4(var,v) 
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var4
+
+SUBROUTINE err(ierr,typ,nam)
+  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
+  IF(ierr==NF90_NoERR) RETURN
+  SELECT CASE(typ)
+    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
+    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
+  END SELECT
+  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
+END SUBROUTINE err
+
+END SUBROUTINE read_data_gcm
Index: trunk/LMDZ.COMMON/libf/evolution/read_data_humidity.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/read_data_humidity.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/read_data_humidity.F90	(revision 2794)
@@ -0,0 +1,139 @@
+!
+! $Id $
+!
+SUBROUTINE read_data_humidity(fichnom,iim_input,jjm_input,nlayer,timelen, nslope,q_h2o_GCM,q_co2_GCM,ps_GCM,tsurf_gcm)
+
+      use netcdf, only: nf90_open,NF90_NOWRITE,nf90_noerr,nf90_strerror, &
+                        nf90_get_var, nf90_inq_varid, nf90_inq_dimid, &
+                        nf90_inquire_dimension,nf90_close
+      use comsoil_h, only: nsoilmx
+
+      IMPLICIT NONE
+
+!=======================================================================
+!
+! Read initial confitions file to compute the ice table
+!
+!=======================================================================
+
+  include "dimensions.h"
+
+!===============================================================================
+! Arguments:
+  CHARACTER(LEN=*), INTENT(IN) :: fichnom          !--- FILE NAME
+
+  INTEGER, INTENT(IN) :: iim_input,jjm_input,nlayer,nslope,timelen
+
+! atmosphere
+
+  REAL, INTENT(OUT) ::  q_h2o_GCM(iim_input+1,jjm_input+1,timelen)
+  REAL, INTENT(OUT) ::  q_co2_GCM(iim_input+1,jjm_input+1,timelen)
+
+  REAL,  INTENT(OUT) ::  ps_GCM(iim_input+1,jjm_input+1,timelen)
+
+
+! Surface
+  REAL ,INTENT(OUT) ::  tsurf_gcm(iim_input+1,jjm_input+1,nslope,timelen) ! Surface temperature of the concatenated file
+
+
+
+!===============================================================================
+!   Local Variables 
+  CHARACTER(LEN=256) :: msg, var, modname
+  INTEGER,PARAMETER :: length=100
+  INTEGER :: iq, fID, vID, idecal
+  INTEGER :: ierr
+  CHARACTER(len=12) :: start_file_type="earth" ! default start file type
+
+  REAL,ALLOCATABLE :: time(:) ! times stored in start
+  INTEGER :: indextime ! index of selected time
+
+  INTEGER :: edges(4),corner(4)
+  INTEGER :: i,j,t
+  real,save :: m_co2, m_noco2, A , B, mmean
+
+  INTEGER :: islope
+  CHARACTER*2 :: num
+
+
+!-----------------------------------------------------------------------
+  modname="pemetat0"
+
+      m_co2 = 44.01E-3  ! CO2 molecular mass (kg/mol)   
+      m_noco2 = 33.37E-3  ! Non condensible mol mass (kg/mol)   
+      A =(1/m_co2 - 1/m_noco2)
+      B=1/m_noco2
+
+!  Open initial state NetCDF file
+  var=fichnom
+  CALL err(NF90_OPEN(var,NF90_NOWRITE,fID),"open",var)
+
+  CALL get_var3("co2_cropped" ,q_co2_GCM)
+  CALL get_var3("h2o_cropped" ,q_h2o_GCM)
+  CALL get_var3("ps"   ,ps_GCM)
+
+
+  DO islope=1,nslope
+    write(num,fmt='(i2.2)') islope
+    call get_var3("tsurf_slope"//num,tsurf_gcm(:,:,islope,:))
+  ENDDO
+
+  print *, "tsurf_slope"
+
+
+
+
+
+  CONTAINS
+
+SUBROUTINE check_dim(n1,n2,str1,str2)
+  INTEGER,          INTENT(IN) :: n1, n2
+  CHARACTER(LEN=*), INTENT(IN) :: str1, str2
+  CHARACTER(LEN=256) :: s1, s2
+  IF(n1/=n2) THEN
+    s1='value of '//TRIM(str1)//' ='
+    s2=' read in starting file differs from parametrized '//TRIM(str2)//' ='
+    WRITE(msg,'(10x,a,i4,2x,a,i4)')TRIM(s1),n1,TRIM(s2),n2
+    CALL ABORT_gcm(TRIM(modname),TRIM(msg),1)
+  END IF
+END SUBROUTINE check_dim
+
+
+SUBROUTINE get_var1(var,v)
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var1
+
+
+SUBROUTINE get_var3(var,v) ! on U grid
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+
+END SUBROUTINE get_var3
+
+SUBROUTINE get_var4(var,v) 
+  CHARACTER(LEN=*), INTENT(IN)  :: var
+  REAL,             INTENT(OUT) :: v(:,:,:,:)
+  CALL err(NF90_INQ_VARID(fID,var,vID),"inq",var)
+  CALL err(NF90_GET_VAR(fID,vID,v),"get",var)
+END SUBROUTINE get_var4
+
+SUBROUTINE err(ierr,typ,nam)
+  INTEGER,          INTENT(IN) :: ierr   !--- NetCDF ERROR CODE
+  CHARACTER(LEN=*), INTENT(IN) :: typ    !--- TYPE OF OPERATION
+  CHARACTER(LEN=*), INTENT(IN) :: nam    !--- FIELD/FILE NAME
+  IF(ierr==NF90_NoERR) RETURN
+  SELECT CASE(typ)
+    CASE('inq');   msg="Field <"//TRIM(nam)//"> is missing"
+    CASE('get');   msg="Reading failed for <"//TRIM(nam)//">"
+    CASE('open');  msg="File opening failed for <"//TRIM(nam)//">"
+    CASE('close'); msg="File closing failed for <"//TRIM(nam)//">"
+  END SELECT
+  CALL ABORT_gcm(TRIM(modname),TRIM(msg),ierr)
+END SUBROUTINE err
+
+END SUBROUTINE read_data_humidity
Index: trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90	(revision 2792)
+++ trunk/LMDZ.COMMON/libf/evolution/recomp_tend_co2_slope.F90	(revision 2794)
@@ -2,5 +2,5 @@
 ! $Id $
 !
-SUBROUTINE recomp_tend_co2_slope(tendencies_co2_ice_phys,vmr_co2_gcm,ps_GCM_2,global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
+SUBROUTINE recomp_tend_co2_slope(tendencies_co2_ice_phys,tendencies_co2_ice_phys_ini,vmr_co2_gcm,vmr_co2_pem,ps_GCM_2,global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
 
       IMPLICIT NONE
@@ -16,13 +16,17 @@
 
 !   INPUT
-  INTEGER, intent(in) :: timelen,ngrid,nslope                    ! # of timepoint if diagfi, # grid point, # subslope
-  REAL, INTENT(in) ::  vmr_co2_gcm(ngrid,timelen)                ! physical point x timelen field : Volume mixing ratio of co2 in the first layer
-  REAL, intent(in) :: ps_GCM_2(ngrid,timelen)                    ! physical point x timelen field : Surface pressure in the GCM
-  REAL, intent(in) :: global_ave_press_GCM                       ! Average pressure in the GCM output
-  REAL, intent(in) :: global_ave_press_new                       ! Actual average pressure
+  INTEGER, intent(in) :: timelen,ngrid,nslope
+  REAL, INTENT(in) ::  vmr_co2_gcm(ngrid,timelen)                ! physical point field : Volume mixing ratio of co2 in the first layer
+  REAL, INTENT(in) ::  vmr_co2_pem(ngrid,timelen)                ! physical point field : Volume mixing ratio of co2 in the first layer
+  REAL, intent(in) :: ps_GCM_2(ngrid,timelen)                 ! physical point field : Surface pressure in the GCM
+!  REAL, INTENT(in) ::  q_co2_GCM(ngrid)                ! physical point field : Density of co2 in the first layer
+!  REAL, intent(in) :: ps_GCM(ngrid)                 ! physical point field : Density of co2 in the first layer
+  REAL, intent(in) :: global_ave_press_GCM
+  REAL, intent(in) :: global_ave_press_new
+  REAL, intent(in) ::  tendencies_co2_ice_phys_ini(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
 
 
 !   OUTPUT
-  REAL, intent(inout) ::  tendencies_co2_ice_phys(ngrid,nslope)  ! physical point field : Evolution of perenial ice over one year
+  REAL, intent(inout) ::  tendencies_co2_ice_phys(ngrid,nslope) ! physical point field : Evolution of perenial ice over one year
 
 
@@ -30,6 +34,6 @@
 !   ----
 
-  INTEGER :: i,t,islope                                          ! Loop variables 
-  REAL :: eps, sigma, L, beta, alpha, coef, ave                  ! Constant
+  INTEGER :: i,t,islope
+  REAL :: eps, sigma, L, beta, alpha, coef, ave
 
   eps=0.95
@@ -41,17 +45,29 @@
   coef=669*24*3600*eps*sigma/L
 
+  print *, "coef", coef
+  print *, "global_ave_press_GCM", global_ave_press_GCM
+  print *, "global_ave_press_new", global_ave_press_new
+
 ! Evolution of the water ice for each physical point
   do i=1,ngrid
     do islope=1,nslope
        ave=0.
-       if (tendencies_co2_ice_phys(i,islope).LT. 1E-5 .and. tendencies_co2_ice_phys(i,islope).GT.-1E-5) then
-       else
-         do t=1,timelen
-           ave=ave+(beta/(alpha-log(vmr_co2_gcm(i,t)*ps_GCM_2(i,t)/100)))**4  &
-              -(beta/(alpha-log(vmr_co2_gcm(i,t)*ps_GCM_2(i,t)*global_ave_press_GCM/global_ave_press_new/100)))**4
-         enddo
-         tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys(i,islope)+coef*ave/timelen
-       endif
+    do t=1,timelen
+
+!       write(*,*)'i,t=',i,t,islope, alpha,beta,ave,vmr_co2_gcm(i,t),vmr_co2_pem(i,t),ps_GCM_2(i,t),global_ave_press_GCM,global_ave_press_new
+       ave=ave+(beta/(alpha-log(vmr_co2_gcm(i,t)*ps_GCM_2(i,t)/100)))**4  &
+              -(beta/(alpha-log(vmr_co2_pem(i,t)*ps_GCM_2(i,t)*global_ave_press_GCM/global_ave_press_new/100)))**4
     enddo
+!    print *, "i", i
+!    print *, "tendencies_co2_ice_phys_ini bef", tendencies_co2_ice_phys_ini(i,islope)
+!    tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys_ini(i,islope)+coef*ave/timelen
+    tendencies_co2_ice_phys(i,islope)=tendencies_co2_ice_phys_ini(i,islope)-coef*ave/timelen
+
+!    print *, "tendencies after", tendencies_co2_ice_phys(i,islope)
+!    print *, "ave", ave
+!    print *, "timelen", timelen
+!    print *, "vmr_co2_pem(i,t)*ps_GCM_2(i,t)", vmr_co2_pem(i,t)*ps_GCM_2(i,t)
+!    print *, "-------------------"
+  enddo
   enddo
 
Index: trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/soil_TIfeedback_PEM.F90	(revision 2794)
@@ -0,0 +1,99 @@
+      SUBROUTINE soil_TIfeedback_PEM(ngrid,nsoil,icecover,   newtherm_i)
+
+!      use tracer_mod, only:  rho_ice
+      use comsoil_h_PEM, only: layer_PEM, inertiedat_PEM
+
+      IMPLICIT NONE
+
+!=======================================================================
+!   Description :
+!       Surface water ice / Thermal inertia feedback.
+!
+!   When surface water-ice is thick enough, this routine creates a new
+!   soil thermal inertia with three different layers :
+!   - One layer of surface water ice (the thickness is given
+!     by the variable icecover (in kg of ice per m2) and the thermal
+!     inertia is prescribed by inert_h2o_ice (see surfdat_h)); 
+!   - A transitional layer of mixed thermal inertia;
+!   - A last layer of regolith below the ice cover whose thermal inertia
+!     is equal to inertiedat.
+!
+!  To use the model :
+!      SET THE tifeedback LOGICAL TO ".true." in callphys.def.
+!
+!  Author: Adapted from J.-B. Madeleine Mars 2008 ( Updated November 2012) by LL, 2022
+!=======================================================================
+ 
+
+!Local variables
+!---------------
+
+      INTEGER :: ig                     ! Grid point (ngrid)
+      INTEGER :: ik                     ! Grid point (nsoil)
+      INTEGER :: iref                   ! Ice/Regolith boundary index
+      INTEGER, INTENT(IN) :: ngrid                  ! Number of horizontal grid points 
+      INTEGER, INTENT(IN) :: nsoil                  ! Number of soil layers 
+      REAL :: icedepth                  ! Ice cover thickness (m)
+      REAL :: inert_h2o_ice = 800.
+      REAL :: rho_ice = 920.
+      REAL :: prev_thermi(ngrid,nsoil)
+!Inputs
+!------
+
+      REAL ,INTENT(IN):: icecover(ngrid)         ! tracer on the surface (kg.m-2)
+                                       
+                                        ! water ice
+!Outputs
+!-------
+
+      REAL,INTENT(INOUT) :: newtherm_i(ngrid,nsoil)    ! New soil thermal inertia
+
+
+      prev_thermi(:,:) = newtherm_i(:,:)
+
+!Creating the new soil thermal inertia table
+!-------------------------------------------
+      DO ig=1,ngrid
+!      Calculating the ice cover thickness
+       
+        icedepth=icecover(ig)/rho_ice
+       
+!      If the ice cover is too thick or watercaptag=true,
+!        the entire column is changed :
+        IF (icedepth.ge.layer_PEM(nsoil)) THEN
+          DO ik=1,nsoil
+               newtherm_i(ig,ik)=max(inert_h2o_ice,prev_thermi(ig,ik))
+          ENDDO 
+!      We neglect the effect of a very thin ice cover :
+        ELSE IF (icedepth.lt.layer_PEM(1)) THEN
+          DO ik=1,nsoil
+               newtherm_i(ig,ik)=inertiedat_PEM(ig,ik)
+          ENDDO 
+        ELSE
+!        Ice/regolith boundary index :
+          iref=1
+!        Otherwise, we find the ice/regolith boundary:
+          DO ik=1,nsoil-1
+              IF ((icedepth.ge.layer_PEM(ik)).and. (icedepth.lt.layer_PEM(ik+1))) THEN
+                  iref=ik+1
+                  EXIT
+              ENDIF
+          ENDDO
+!        And we change the thermal inertia:
+          DO ik=1,iref-1
+            newtherm_i(ig,ik)=max(inert_h2o_ice,prev_thermi(ig,ik))
+          ENDDO
+!        Transition (based on the equations of thermal conduction):
+          newtherm_i(ig,iref)=sqrt( (layer_PEM(iref)-layer_PEM(iref-1)) / &
+           ( ((icedepth-layer_PEM(iref-1))/newtherm_i(ig,iref-1)**2) + &
+             ((layer_PEM(iref)-icedepth)/inertiedat_PEM(ig,ik)**2) ) )
+!        Underlying regolith:
+          DO ik=iref+1,nsoil
+              newtherm_i(ig,ik)=inertiedat_PEM(ig,ik)
+          ENDDO
+        ENDIF ! icedepth
+      ENDDO ! ig
+
+!=======================================================================
+      RETURN
+      END
Index: trunk/LMDZ.COMMON/libf/evolution/soil_evolution_mod.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/evolution/soil_evolution_mod.F90	(revision 2794)
+++ trunk/LMDZ.COMMON/libf/evolution/soil_evolution_mod.F90	(revision 2794)
@@ -0,0 +1,154 @@
+      MODULE soil_evolution_mod
+
+
+      IMPLICIT NONE
+      
+      CONTAINS    
+
+
+     subroutine soil_pem_CN(ngrid,nsoil, &
+               therm_i, timestep,tsurf,tsurf_prev,tsoil)
+
+
+      use comsoil_h_PEM, only:   & fluxgeo,layer_PEM
+      use comsoil_h,only: volcapa
+      implicit none
+
+!-----------------------------------------------------------------------
+!  Author: LL
+!  Purpose: Compute soil temperature using an implict 1st order scheme
+!  
+!  Note: depths of layers and mid-layers, soil thermal inertia and 
+!        heat capacity are commons in comsoil_PEM.h
+!        A convergence loop is added until equilibrium
+!-----------------------------------------------------------------------
+
+#include "dimensions.h"
+!#include "dimphys.h"
+
+!#include"comsoil.h"
+
+
+!-----------------------------------------------------------------------
+!  arguments
+!  ---------
+!  inputs:
+      integer,intent(in) :: ngrid	! number of (horizontal) grid-points 
+      integer,intent(in) :: nsoil	! number of soil layers  
+      real,intent(in) :: therm_i(ngrid,nsoil) ! thermal inertia
+      real,intent(in) :: timestep	    ! time step
+      real,intent(in) :: tsurf(ngrid)   ! surface temperature
+      real,intent(in) :: tsurf_prev(ngrid)   ! surface temperature at previous timestep
+
+! outputs:
+      real,intent(inout) :: tsoil(ngrid,nsoil) ! soil (mid-layer) temperature
+
+
+      
+! local variables:
+      integer ig,ik,isoil
+      REAL :: ice_inertia = 2120.
+      real :: alph_PEM(nsoil)
+      real :: beta_PEM(nsoil)
+      real :: rhoc(nsoil)
+      real :: volcapa_ice = 1.43e7
+
+      real :: k_soil(nsoil)
+      real :: d1(nsoil),d2(nsoil),d3(nsoil),re(nsoil)
+      real :: Tcol(nsoil)
+
+
+do ig = 1,ngrid
+
+   Tcol(:) = tsoil(ig,:)
+!0. Build thermal properties of the ground
+
+
+  do isoil = 1,nsoil
+    if(abs(ice_inertia-therm_i(ig,isoil)).lt.1e-6) then
+      rhoc(isoil) = volcapa_ice
+    else
+      rhoc(isoil) = volcapa
+    endif
+    k_soil(isoil) = therm_i(ig,isoil)*therm_i(ig,isoil)/rhoc(isoil)
+  enddo
+
+!1. Build Crank-Nicholson scheme for heat equation, following Schorgofer derivations
+!1.a all the points which are not impacted by boundary condition
+  do isoil = 2,nsoil-1
+    
+    alph_pem(isoil) = timestep/((rhoc(isoil) + rhoc(isoil+1))/2.)*k_soil(isoil+1)/((layer_PEM(isoil+1) - layer_PEM(isoil))*(layer_PEM(isoil+1) - layer_PEM(isoil-1)))
+    beta_pem(isoil) = timestep/((rhoc(isoil) + rhoc(isoil+1))/2.)*k_soil(isoil)/((layer_PEM(isoil) - layer_PEM(isoil-1))*(layer_PEM(isoil+1) - layer_PEM(isoil-1)))
+  enddo
+
+!1.b At the surface: T(z=0) = Tsurf.
+
+alph_pem(1) = k_soil(2)*timestep/(rhoc(1)*layer_PEM(2)*(layer_PEM(2)-layer_PEM(1)))
+beta_pem(1) = k_soil(1)*timestep/(rhoc(1)*layer_PEM(2)*layer_PEM(1))
+
+
+
+!1.c At the bottom: dT/dz = -Fgeo/k.
+beta_pem(nsoil) = timestep*k_soil(nsoil)/(2.*rhoc(nsoil)*(layer_PEM(isoil) - layer_PEM(isoil-1))**2)
+
+!1 .d set the tridiagonal with diagonals d1,d2,d3, and right element re: 
+
+
+  d1(:) = -beta_pem(:)   
+  d2(:) = 1. + alph_pem(:) + beta_pem(:)
+  d3(:) = -alph_pem(:)   
+  d2(nsoil) = 1. + beta_pem(nsoil)
+ 
+  re(1)= alph_pem(1)*Tcol(2) + (1.-alph_pem(1)-beta_pem(1))*Tcol(1) + beta_pem(1)*(tsurf(ig)+tsurf_prev(ig))
+  do isoil=2,nsoil-1
+     re(isoil) = beta_pem(isoil)*Tcol(isoil-1) + (1.-alph_pem(isoil)-beta_pem(isoil))*Tcol(isoil) + alph_pem(isoil)*Tcol(isoil+1)
+  enddo
+  re(nsoil) = beta_pem(nsoil)*Tcol(nsoil-1) + (1.-beta_pem(nsoil))*Tcol(nsoil) + &
+  timestep/rhoc(nsoil)*fluxgeo/(layer_PEM(nsoil)-layer_PEM(nsoil-1)) 
+
+
+
+!2. Update by tridiagonal inversion 
+  call tridag(d1,d2,d3,re,Tcol,nsoil) 
+  
+
+
+      tsoil(ig,:) = Tcol(:)
+  enddo
+
+
+      END SUBROUTINE soil_pem_CN
+
+!====================================
+
+      SUBROUTINE TRIDAG(A,B,C,R,U,N)
+! From Numerical Recipes in Fortran 77
+      INTEGER, INTENT(IN)::  N
+      INTEGER ,PARAMETER:: NMAX = 1000
+
+      REAL, INTENT(IN) :: A(N),B(N),C(N),R(N)
+      REAL,INTENT(INOUT) :: U(N)
+
+      INTEGER j
+      REAL bet,gam(NMAX)
+
+      IF(B(1).EQ.0.)PAUSE
+      BET=B(1)
+      U(1)=R(1)/BET
+      DO 11 J=2,N
+        GAM(J)=C(J-1)/BET
+        BET=B(J)-A(J)*GAM(J)
+        IF(BET.EQ.0.)PAUSE
+        U(J)=(R(J)-A(J)*U(J-1))/BET
+11    CONTINUE
+      DO 12 J=N-1,1,-1
+        U(J)=U(J)-GAM(J+1)*U(J+1)
+12    CONTINUE
+      RETURN
+      END  SUBROUTINE TRIDAG
+
+
+      END MODULE soil_evolution_mod
+
+
+      
